/*
 * p6010_lamp_off_timer_avrprojevt.c
 *
 * Created: 15.02.2014 0:01:21
 *  Author: axillent
 */


#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <util/delay.h>

#define RELAY		(1 << PINB0)

#define TIME_BIT0	(1 << PINB1)
#define TIME_BIT1	(1 << PINB3)
#define TIME_BIT2	(1 << PINB2)

#define TIME_DELAY(b0, b1, b2)	10 + 20*((b2 << 2) | (b1 << 1) | b0);

uint8_t time2(void) { return (PINB & TIME_BIT2)?1:0; }
uint8_t time1(void) { return (PINB & TIME_BIT1)?1:0; }
uint8_t time0(void) { return (PINB & TIME_BIT0)?1:0; }

void lamp_on(void) { PORTB |= RELAY; }
void lamp_off(void) { PORTB &= ~RELAY; }

volatile uint8_t second;
volatile uint8_t var_timer_min;

uint8_t var_delay_min;

ISR(TIM0_COMPA_vect) {
	if(++second == 60) {
		second = 0;
		var_timer_min++;
//	if(PINB & RELAY) lamp_off(); else lamp_on();
	}	
}

int main(void)
{
	// prescaler /256 
	// clock = 31250
	CCP = 0xD8;
	CLKPSR = (1 << CLKPS3) | (0 << CLKPS2) | (0 << CLKPS1) | (0 << CLKPS0);

	//   
	DDRB |= RELAY;
	
	second = 0;
	var_timer_min = 0;

	//      
	PUEB |= TIME_BIT2 | TIME_BIT1 | TIME_BIT0;
	//   
	_delay_ms(500);
	var_delay_min = TIME_DELAY(time0(), time1(), time2());

	//  
	TCCR0B = (1 << CS00) | (1 << WGM02);
	OCR0A = 31250;
	TCNT0 = 0;
	TIMSK0 |= (1 << OCIE0A);


	//  
	lamp_on();
	sei();

    while(1)
    {
		if(var_timer_min >= var_delay_min) {
			lamp_off();		//  
			while(1) {
				//     
				ACSR |= (1 << ACD);
				set_sleep_mode(SLEEP_MODE_PWR_DOWN);
				cli();
				sleep_enable();
				sleep_cpu();
			}
		}	
		//   	
		set_sleep_mode(SLEEP_MODE_IDLE);
		sleep_enable();
		sei();
		sleep_cpu();
		sleep_disable();
    }
}